import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program } from "@coral-xyz/anchor";
import { Staking } from "../artifacts/staking";

export type ClaimParams = {
  accounts: {
    user: PublicKey;
  };
};

export async function claim(
  program: Program<Staking>,
  params: ClaimParams,
): Promise<Instruction> {
  const { accounts } = params;

  const ix = await program.methods
    .claim()
    .accounts({
      ...accounts,
    })
    .instruction();

  return {
    instructions: [ix],
    cleanupInstructions: [],
    signers: [],
  };
}
