import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program } from "@coral-xyz/anchor";
import { Staking } from "../artifacts/staking";

export type InitFlexibleAccountParams = {
  accounts: {
    user: PublicKey;
  };
  inputs: {
    bump: number;
  };
};

export async function initFlexibleAccount(
  program: Program<Staking>,
  params: InitFlexibleAccountParams,
): Promise<Instruction> {
  const { accounts, inputs } = params;

  const ix = await program.methods
    .initializeFlexibleAccount(inputs.bump)
    .accounts({
      ...accounts,
    })
    .instruction();

  return {
    instructions: [ix],
    cleanupInstructions: [],
    signers: [],
  };
}
