import { Instruction } from "@orca-so/common-sdk";
import { PublicKey } from "@solana/web3.js";
import { Program } from "@coral-xyz/anchor";
import { Staking } from "../artifacts/staking";

export type WithdrawDelayParams = {
  accounts: {
    user: PublicKey;
  };
  inputs: {
    index: number;
  };
};

export async function withdrawDelay(
  program: Program<Staking>,
  params: WithdrawDelayParams,
): Promise<Instruction> {
  const { accounts, inputs } = params;

  const ix = await program.methods
    .withdrawDelay(inputs.index)
    .accounts({
      ...accounts,
    })
    .instruction();

  return {
    instructions: [ix],
    cleanupInstructions: [],
    signers: [],
  };
}
